#include <gui/window.h>
#include "datum.h"
#include "interp.h"
#include "vis_threading.h"

//class os_window;



class os_window : public os::Window
{
public:
	os_window(datum * vis_wind);
	~os_window();
	void HandleMessage(os::Message * msg);
private:
	datum * vis_wind;
};


struct vis_window_shown
{
	os_window * wind;
	VIS_CRITICAL_SECTION(lock)
	datum * title;
	double width;
	double height;
	double xpos;
	double ypos;
	queue_entry * wait_entry;
	int next_msg_code;
	datum * handler_list;
	BOOL is_open;
};



